#ifndef IEEE_DEFINED
	typedef long	IEEE;
#endif

#define FORM	0x464F524D	/* All fonts are a FORM */

struct FORMstruct {
    long	ID;
    long	Size;		/* Total size of the file */
};

#define OFNT	0x4F464E54	/* ID of outline font file */

#define OFHD	0x4F464844	/* ID of OutlineFontHeaDer */

struct OFHDstruct {
    char	FontName[32];	/* Font name, null padded */
    short	FontAttrs;	/* See FA_*, below */
    IEEE	FontTop,	/* Typical height above baseline */
		FontBot,	/* Typical descent below baseline */
		FontWidth;	/* Typical width, i.e. of the letter O */
};

#define FA_BOLD		0x0001
#define FA_OBLIQUE	0x0002
#define FA_SERIF	0x0004


#define KERN	0x4B45524C	/* Kerning pair */

struct KERNstruct {
    short	Ch1, Ch2;	/* The pair to kern (allows for 16 bits...) */
    IEEE	XDisplace,	/* Amount to displace -left +right */
		YDisplace;	/* Amount to displace -down +up */
};


#define CHDF	0x43484446	/* Character definition */

struct CHDFstruct {
    short	Ch;		/* The character we're defining (ASCII) */
    short	NumPoints;	/* The number of points in the definition */
    IEEE	XWidth,		/* Position for next char on baseline - X */
		YWidth;		/* Position for next char on baseline - Y */
    /* IEEE	Points[2*NumPoints]*/	/* The actual points */
};


#define OFNT_IND	0xFFFFFFFF
#ifndef INDICATOR
#define	INDICATOR	0xFFFFFFFF	/* If X == INDICATOR, Y is an action */
#define	IND_SPLINE	0x00000001	/* Next 4 pts are spline control pts */
#define IND_MOVETO	0x00000002	/* Start new subpoly */
#endif
#define IND_STROKE	0x00000004	/* Stroke previous path */
#define IND_FILL	0x00000008	/* Fill previous path */

/*** EOF ofnt.h ***/
